#|
Sun Jun 3 00:16:23 EST 2007

	In the month of May, 2007, Jerome Damas (a CFI trained "technician in
the dental arts", as he calls himself) undertook a survey of the mouths of the
kids on the Calhoun-Spady campus. He examined 1020 mouths

	This is a file that I used to create some summary information, and to
get a little better picture of the health of the teeth of the kids of Haiti, as
represented by the cross-section of students of Ranquitte.

	In general I would expect that the teeth of the kids in school would be
better, on average, than the teeth of all kids in general (at least in
Ranquitte). Since there are no (practicing) dentists in town, I expect that the
dental health of Ranquitte is worse than that in the major cities (Cap, PAP).

	81% of kids tested had cavities.

Number of kids with maloclusion: 42 (4.12 %)
Number of kids with bleeding gums: 25 (2.45 %)
Number of kids with inflamed gums: 23 (2.25 %)
Number of kids with gingivitus: 8 (0.78 %)
Number of kids with periodontal disease: 1 (0.10 %)


	One interesting detail that I've identified is what appears to be a
mid-life period of fewer cavities, once the baby teeth are gone, and the adult
set isn't ruined yet. It seems to appear at about the age of 13 or 14. 


|#
(def stuff (read-file "dentistry_summary.txt"))
(length stuff)
(def class nil)
(let ()
  (def group nil)
  (dotimes
      (i (length stuff))
    (let (
	  (sign (read-from-string (elt stuff i)))
	  (list (rest
		 (mapcar
		  (lambda(x) (coerce x 'string))
		  (list-split #\Tab (coerce (elt stuff i) 'list))
		  )
		 )
		)
	  )
      (cond
       ((or
	 (eq sign 'number)
	 (eq sign 'caries)
	 (eq sign 'nombre))
	(setq waste t))
       ((numberp sign) 
	(while (/= 11 (length list)) (setq list (append list (list ""))))
	(setq group (append group (append (list class sign) list)))
	(format t "~a ~d ~d ~d ~{\"~a\" ~}~%" i class sign (length list) list))
       (t 
	(setq class sign)
	)
       )
      )
    )
  (def data-mat 
       (apply
	#'bind-rows
	(split-list group 13)
	)
       )
  )
(mvsq
 '(class num nom prenom age caries gingivites inf_gen perio sainglement maloclusion
	 bouche notes)
 (column-list data-mat)
 )
   
(let* (
       (caries (coerce caries 'list))
       (caries
	(mapcar (lambda(x) 
		  (cond
		   ((or (string= x "")(string= x "\r")) 0)
		   (t (read-from-string x))))
		caries))
       (age (coerce age 'list))
       (age 
	(mapcar (lambda(x) 
		  (cond
		   ((or (string= x "")(string= x "\r")) 0)
		   (t (read-from-string x))))
		age))
       (mat
	(bind-columns
	 class nom prenom caries age)
	)
       (keepers (where age 0 #'/=))
       (mat (select mat keepers (iseq 5)))
       )
  (print (max caries))
  (print (where caries 0))
  (format t "~%~,2f% of students with cavities (n=~d)~%" 
	  (* 100 (- 1 (/ (length (where (select caries keepers) 0))
		    (length keepers)
		    )))
	  (length keepers)
	  )
  (let ((ages (where age 12 #'>=)))
    (format t "~,2f% students 12 or older with cavities (n=~d)~%" 
	    (* 100 
	       (- 1 (/ (length (where (select caries (intersection keepers ages)) 0))
		  (length (intersection keepers ages))
		  )))
	    (length (intersection keepers ages))
	    )
    )
  (let ((ages (where age 12)))
    (format t "~,2f% students 12 year olds with cavities (n=~d)~%" 
	    (* 100 
	       (- 1 (/ (length (where (select caries (intersection keepers ages)) 0))
		  (length (intersection keepers ages))
		  )))
	    (length (intersection keepers ages))
	    )
    )
  (print (row 1 mat))
  (print (size caries keepers))
  (write-matrix-to-file 
   (sort-matrix mat 4 :high-low t)
   "cavities.txt"
   :separator "	"
   :header "class	name	first-name	cavities	age"
   )
  (write-matrix-to-file 
   (but-cols (sort-matrix mat 4 :high-low t) '(1 2))
   "cavities_all.txt"
   :separator "	"
   :header "class	cavities	age"
   )
  )

(def num_age
     (mapcar (lambda(x) 
	       (cond
		((or (string= x "")(string= x "\r")) 0)
		(t (read-from-string x))))
	     (coerce age 'list)
	     )
     )
(def num_caries
     (mapcar (lambda(x) 
	       (cond
		((or (string= x "")(string= x "\r")) 0)
		(t (read-from-string x))))
	     (coerce caries 'list)
	     )
     )
(def yes (where num_age 0 #'/=))
(def num_age (select num_age yes))
(def num_caries (select num_caries yes))

(lines nil)
(plot num_age num_caries)
(title "Cavities of Students")
(histo num_caries :my-cutpoints (- (iseq 0 (1+ (max num_caries))) .5))
(title "Ages of Students")
(histo num_age :my-cutpoints (- (iseq (1+ (min num_age)) (1+ (max num_age))) .5))

(def ages (iseq (min num_age) (max num_age)))
(def age-classes
     (mapcar
      (lambda(x) (length (where num_age x)))
      ages)
     )

(def width 2)
(title (format 
	nil
	"kernel-smoothed cavities against age; age width ~,1f"
	width))
(def smoothed-total
     (kernel-smoother
      (weave num_age num_caries)
      ages
      #'(lambda(x) (exp (- (^ (/ x width) 2))))
      )
     )
(plot
 ages
 smoothed-total
 )
(def age-sd
     (mapcar
      (lambda(x)
	(let ((where (where num_age x)))
	  (if (> (length (select num_caries where)) 1)
	      (list
	       (mean (select num_caries where))
	       (sd (select num_caries where))
	       )
	    )
	  )
	)
      ages
      )
     )
(def age-smooth (select smoothed-total (which age-sd)))
(def age-useful (select ages (which age-sd)))
(def age-class (select age-classes (which age-sd)))
(def age-means (mapcar #'first (select age-sd (which age-sd))))
(def age-sd (mapcar #'second (select age-sd (which age-sd))))

(plot ages age-classes)
(let ()
  (plot age-useful age-means)
  (send my-plot
	:add-plot-item
	(list
	 'points
	 (combine age-useful age-useful)
	 (combine (- age-means (/ age-sd (sqrt age-class))) 
		  (+ age-means (/ age-sd (sqrt age-class))))
	 'black
	 'cross
	 )
	)
  (send my-plot
	:add-plot-item
	(list
	 'points
	 age-useful
	 age-smooth
	 'red
	 'disk
	 )
	)
  (send my-plot
	:add-plot-item
	(list
	 'lines
	 age-useful
	 age-smooth
	 'red
	 )
	)
  (mapcar
   (lambda(age mean sd)
     (send my-plot
	:add-plot-item
	(list
	 'lines
	 (list age age)
	 (list (- mean sd) (+ mean sd))
	 'black
	 'cross
	 )
	)
     )
   age-useful age-means (/ age-sd (sqrt age-class))
   )
  (send my-plot :adjust-to-data :draw t)
  (postscript "adolescent-dip.ps")
  )

(let* (
       (xpoints (combine age-useful age-useful))
       (ypoints
	(combine (- age-means (/ age-sd (sqrt age-class))) 
		 (+ age-means (/ age-sd (sqrt age-class))))
	)
       (m (length xpoints))
       (n (length age-useful))
       xx yy
       (linestuff
	(mapcar
	 (lambda(age mean sd)
	   (setq xx (append xx (repeat age 4))
		 yy (append yy (list mean (- mean sd) (+ mean sd) mean))
		 )
	   )
	 age-useful age-means (/ age-sd (sqrt age-class))
	 )
	)
       )
  (xgobips "adolescent-dip2.ps"
	   0  ;; red   level 
	   0  ;; green
	   0  ;; blue
	   age-useful age-smooth
	   :points (list (list
			  (combine (repeat 0 m) (repeat 1 n))
			  (combine (repeat 1 m) (repeat 0 n))
			  (combine (repeat 0 m) (repeat 1 n))
			  (combine (repeat 3 m) (repeat 1 n))
			  (combine (repeat 5 m) (repeat 5 n))
			  (combine xpoints age-useful)
			  (combine ypoints age-smooth)
			  ))
	   :morelines (list (list 0 0 1 xx yy "lndashed"))
	   :ymin 0
	   :ymax 4
	   :ytics (iseq 5)
	   :xtickfmt "~d"
	   :ytickfmt "~d"
	   :title *title*
	   :xlabel "Age"
	   :ylabel "Cavities"
	   )
  )

(defun jitter(x factor &key (fn 'normal-rand))
  (if (listp x)
      (+ x (* (funcall fn (length x)) factor))
    (+ x (* (funcall fn 1) factor))
    )
  )
(plot 
 (jitter num_age 1 :fn (lambda(x) (- (uniform-rand x) .5)))
 (jitter num_caries .1 :fn #'uniform-rand)
 )

(send my-plot
      :add-plot-item
      (list
       'points
       ages (/ age-classes 24)
       'red
       'diamond
       )
      )
(send my-plot
      :add-plot-item
      (list
       'lines
       ages (/ age-classes 24)
       'red
       )
      )

;; Binaries...
(mapcar
 (lambda(var name)
   (let* (
	  (var (coerce var 'list))
	  (var
	   (mapcar (lambda(x) 
		     (cond
		      ((or (string= x "")(string= x "\r")) 0)
		      (t (read-from-string x))))
		   var))
	  (mat
	   (bind-columns
	    class nom prenom var)
	   )
	  (keepers (where var 1))
	  (mat (select mat keepers (iseq 4)))
	  )
     (format t "Number of kids with ~a: ~d (~,2f %)~%" name (length keepers) (/  (length
									 keepers) 10.20))
     (write-matrix-to-file 
      (sort-matrix mat 2 :high-low nil)
      (strcat name ".txt")
      :separator "	"
      :header (strcat "class	name	first-name	" name)
      )
     )
   )
 (list maloclusion gingivites inf_gen perio sainglement)
 (list "maloclusion" "gingivites" "inf_gen" "perio" "sainglement")
 )

